diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/wifi-helper.cc ns-3.34/src/wifi/helper/wifi-helper.cc
--- ns-3.33/src/wifi/helper/wifi-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/wifi-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -21,8 +21,6 @@
  */
 
 #include "ns3/wifi-net-device.h"
-#include "ns3/minstrel-wifi-manager.h"
-#include "ns3/minstrel-ht-wifi-manager.h"
 #include "ns3/ap-wifi-mac.h"
 #include "ns3/ampdu-subframe-header.h"
 #include "ns3/mobility-model.h"
@@ -38,7 +36,6 @@
 #include "ns3/vht-configuration.h"
 #include "ns3/he-configuration.h"
 #include "ns3/obss-pd-algorithm.h"
-#include "ns3/wifi-ack-policy-selector.h"
 #include "wifi-helper.h"
 
 namespace ns3 {
@@ -387,10 +384,6 @@
         }
 
       mcsKnown |= RadiotapHeader::MCS_KNOWN_HT_FORMAT;
-      if (preamble == WIFI_PREAMBLE_HT_GF)
-        {
-          mcsFlags |= RadiotapHeader::MCS_FLAGS_HT_GREENFIELD;
-        }
 
       mcsKnown |= RadiotapHeader::MCS_KNOWN_NESS;
       if (txVector.GetNess () & 0x01) //bit 1
@@ -498,8 +491,8 @@
         {
           data2 |= RadiotapHeader::HE_DATA2_RU_OFFSET_KNOWN;
           //HeRu indices start at 1 whereas RadioTap starts at 0
-          data2 |= (((txVector.GetHeMuUserInfo (staId).ru.index - 1) << 8) & 0x3f00);
-          data2 |= (((!txVector.GetHeMuUserInfo (staId).ru.primary80MHz) << 15) & 0x8000);
+          data2 |= (((txVector.GetHeMuUserInfo (staId).ru.GetIndex () - 1) << 8) & 0x3f00);
+          data2 |= (((!txVector.GetHeMuUserInfo (staId).ru.GetPrimary80MHz ()) << 15) & 0x8000);
         }
 
       uint16_t data3 = 0;
@@ -515,7 +508,7 @@
       uint16_t data5 = 0;
       if (preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB)
         {
-          HeRu::RuType ruType = txVector.GetHeMuUserInfo (staId).ru.ruType;
+          HeRu::RuType ruType = txVector.GetHeMuUserInfo (staId).ru.GetRuType ();
           switch (ruType)
             {
             case HeRu::RU_26_TONE:
@@ -722,10 +715,6 @@
     m_selectQueueCallback (&SelectQueueByDSField)
 {
   SetRemoteStationManager ("ns3::ArfWifiManager");
-  SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector");
-  SetAckPolicySelectorForAc (AC_BK, "ns3::ConstantWifiAckPolicySelector");
-  SetAckPolicySelectorForAc (AC_VI, "ns3::ConstantWifiAckPolicySelector");
-  SetAckPolicySelectorForAc (AC_VO, "ns3::ConstantWifiAckPolicySelector");
 }
 
 void
@@ -775,29 +764,6 @@
 }
 
 void
-WifiHelper::SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                       std::string n0, const AttributeValue &v0,
-                                       std::string n1, const AttributeValue &v1,
-                                       std::string n2, const AttributeValue &v2,
-                                       std::string n3, const AttributeValue &v3,
-                                       std::string n4, const AttributeValue &v4,
-                                       std::string n5, const AttributeValue &v5,
-                                       std::string n6, const AttributeValue &v6,
-                                       std::string n7, const AttributeValue &v7)
-{
-  m_ackPolicySelector[ac] = ObjectFactory ();
-  m_ackPolicySelector[ac].SetTypeId (type);
-  m_ackPolicySelector[ac].Set (n0, v0);
-  m_ackPolicySelector[ac].Set (n1, v1);
-  m_ackPolicySelector[ac].Set (n2, v2);
-  m_ackPolicySelector[ac].Set (n3, v3);
-  m_ackPolicySelector[ac].Set (n4, v4);
-  m_ackPolicySelector[ac].Set (n5, v5);
-  m_ackPolicySelector[ac].Set (n6, v6);
-  m_ackPolicySelector[ac].Set (n7, v7);
-}
-
-void
 WifiHelper::SetStandard (WifiStandard standard)
 {
   m_standard = standard;
@@ -818,9 +784,6 @@
     case WIFI_PHY_STANDARD_80211g:
       m_standard = WIFI_STANDARD_80211g;
       return;
-    case WIFI_PHY_STANDARD_holland:
-      m_standard = WIFI_STANDARD_holland;
-      return;
     // remove the next value from WifiPhyStandard when deprecation ends
     case WIFI_PHY_STANDARD_80211n_2_4GHZ:
       m_standard = WIFI_STANDARD_80211n_2_4GHZ;
@@ -876,10 +839,8 @@
           device->SetHeConfiguration (heConfiguration);
         }
       Ptr<WifiRemoteStationManager> manager = m_stationManager.Create<WifiRemoteStationManager> ();
-      Ptr<WifiMac> mac = macHelper.Create (device);
+      Ptr<WifiMac> mac = macHelper.Create (device, m_standard);
       Ptr<WifiPhy> phy = phyHelper.Create (node, device);
-      mac->SetAddress (Mac48Address::Allocate ());
-      mac->ConfigureStandard (m_standard);
       phy->ConfigureStandardAndBand (it->second.phyStandard, it->second.phyBand);
       device->SetMac (mac);
       device->SetPhy (phy);
@@ -899,51 +860,26 @@
         {
           Ptr<NetDeviceQueueInterface> ndqi;
           BooleanValue qosSupported;
-          PointerValue ptr;
           Ptr<WifiMacQueue> wmq;
-          Ptr<WifiAckPolicySelector> ackSelector;
 
           rmac->GetAttributeFailSafe ("QosSupported", qosSupported);
           if (qosSupported.Get ())
             {
               ndqi = CreateObjectWithAttributes<NetDeviceQueueInterface> ("NTxQueues",
                                                                           UintegerValue (4));
-
-              rmac->GetAttributeFailSafe ("BE_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_BE].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-              wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
-              ndqi->GetTxQueue (0)->ConnectQueueTraces (wmq);
-
-              rmac->GetAttributeFailSafe ("BK_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_BK].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-              wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
-              ndqi->GetTxQueue (1)->ConnectQueueTraces (wmq);
-
-              rmac->GetAttributeFailSafe ("VI_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_VI].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-              wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
-              ndqi->GetTxQueue (2)->ConnectQueueTraces (wmq);
-
-              rmac->GetAttributeFailSafe ("VO_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_VO].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-              wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
-              ndqi->GetTxQueue (3)->ConnectQueueTraces (wmq);
+              for (auto& ac : {AC_BE, AC_BK, AC_VI, AC_VO})
+                {
+                  Ptr<QosTxop> qosTxop = rmac->GetQosTxop (ac);
+                  wmq = qosTxop->GetWifiMacQueue ();
+                  ndqi->GetTxQueue (static_cast<std::size_t> (ac))->ConnectQueueTraces (wmq);
+                }
               ndqi->SetSelectQueueCallback (m_selectQueueCallback);
             }
           else
             {
               ndqi = CreateObject<NetDeviceQueueInterface> ();
 
-              rmac->GetAttributeFailSafe ("Txop", ptr);
-              wmq = ptr.Get<Txop> ()->GetWifiMacQueue ();
+              wmq = rmac->GetTxop ()->GetWifiMacQueue ();
               ndqi->GetTxQueue (0)->ConnectQueueTraces (wmq);
             }
           device->AggregateObject (ndqi);
@@ -988,58 +924,82 @@
   LogComponentEnable ("AparfWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("ArfWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("BlockAckAgreement", LOG_LEVEL_ALL);
-  LogComponentEnable ("BlockAckCache", LOG_LEVEL_ALL);
+  LogComponentEnable ("RecipientBlockAckAgreement", LOG_LEVEL_ALL);
   LogComponentEnable ("BlockAckManager", LOG_LEVEL_ALL);
   LogComponentEnable ("CaraWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("ChannelAccessManager", LOG_LEVEL_ALL);
   LogComponentEnable ("ConstantObssPdAlgorithm", LOG_LEVEL_ALL);
   LogComponentEnable ("ConstantRateWifiManager", LOG_LEVEL_ALL);
-  LogComponentEnable ("ConstantWifiAckPolicySelector", LOG_LEVEL_ALL);
   LogComponentEnable ("ChannelAccessManager", LOG_LEVEL_ALL);
   LogComponentEnable ("DsssErrorRateModel", LOG_LEVEL_ALL);
+  LogComponentEnable ("DsssPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("DsssPpdu", LOG_LEVEL_ALL);
+  LogComponentEnable ("ErpOfdmPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("ErpOfdmPpdu", LOG_LEVEL_ALL);
+  LogComponentEnable ("FrameExchangeManager", LOG_LEVEL_ALL);
   LogComponentEnable ("HeConfiguration", LOG_LEVEL_ALL);
+  LogComponentEnable ("HeFrameExchangeManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("HePhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("HePpdu", LOG_LEVEL_ALL);
   LogComponentEnable ("HtConfiguration", LOG_LEVEL_ALL);
+  LogComponentEnable ("HtFrameExchangeManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("HtPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("HtPpdu", LOG_LEVEL_ALL);
   LogComponentEnable ("IdealWifiManager", LOG_LEVEL_ALL);
-  LogComponentEnable ("InfrastructureWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("InterferenceHelper", LOG_LEVEL_ALL);
-  LogComponentEnable ("MacLow", LOG_LEVEL_ALL);
   LogComponentEnable ("MacRxMiddle", LOG_LEVEL_ALL);
   LogComponentEnable ("MacTxMiddle", LOG_LEVEL_ALL);
   LogComponentEnable ("MinstrelHtWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("MinstrelWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("MpduAggregator", LOG_LEVEL_ALL);
   LogComponentEnable ("MsduAggregator", LOG_LEVEL_ALL);
+  LogComponentEnable ("MultiUserScheduler", LOG_LEVEL_ALL);
   LogComponentEnable ("NistErrorRateModel", LOG_LEVEL_ALL);
   LogComponentEnable ("ObssPdAlgorithm", LOG_LEVEL_ALL);
+  LogComponentEnable ("OfdmPhy", LOG_LEVEL_ALL);
   LogComponentEnable ("OnoeWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("OriginatorBlockAckAgreement", LOG_LEVEL_ALL);
+  LogComponentEnable ("OfdmPpdu", LOG_LEVEL_ALL);
   LogComponentEnable ("ParfWifiManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("PhyEntity", LOG_LEVEL_ALL);
+  LogComponentEnable ("QosFrameExchangeManager", LOG_LEVEL_ALL);
   LogComponentEnable ("QosTxop", LOG_LEVEL_ALL);
   LogComponentEnable ("RegularWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("RraaWifiManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("RrMultiUserScheduler", LOG_LEVEL_ALL);
   LogComponentEnable ("RrpaaWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("SimpleFrameCaptureModel", LOG_LEVEL_ALL);
   LogComponentEnable ("SpectrumWifiPhy", LOG_LEVEL_ALL);
   LogComponentEnable ("StaWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("SupportedRates", LOG_LEVEL_ALL);
   LogComponentEnable ("TableBasedErrorRateModel", LOG_LEVEL_ALL);
+  LogComponentEnable ("ThompsonSamplingWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("ThresholdPreambleDetectionModel", LOG_LEVEL_ALL);
   LogComponentEnable ("Txop", LOG_LEVEL_ALL);
   LogComponentEnable ("VhtConfiguration", LOG_LEVEL_ALL);
-  LogComponentEnable ("WifiAckPolicySelector", LOG_LEVEL_ALL);
+  LogComponentEnable ("VhtFrameExchangeManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("VhtPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("VhtPpdu", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiAckManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiDefaultAckManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiDefaultProtectionManager", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiMacQueue", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiMacQueueItem", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiNetDevice", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPhyStateHelper", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiPhyOperatingChannel", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPpdu", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiProtectionManager", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPsdu", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiRadioEnergyModel", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiRemoteStationManager", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiSpectrumPhyInterface", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiSpectrumSignalParameters", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiTxCurrentModel", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiTxParameters", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiTxTimer", LOG_LEVEL_ALL);
   LogComponentEnable ("YansErrorRateModel", LOG_LEVEL_ALL);
   LogComponentEnable ("YansWifiChannel", LOG_LEVEL_ALL);
   LogComponentEnable ("YansWifiPhy", LOG_LEVEL_ALL);
@@ -1063,18 +1023,7 @@
           currentStream += wifi->GetPhy ()->AssignStreams (currentStream);
 
           //Handle any random numbers in the station managers.
-          Ptr<WifiRemoteStationManager> manager = wifi->GetRemoteStationManager ();
-          Ptr<MinstrelWifiManager> minstrel = DynamicCast<MinstrelWifiManager> (manager);
-          if (minstrel)
-            {
-              currentStream += minstrel->AssignStreams (currentStream);
-            }
-
-          Ptr<MinstrelHtWifiManager> minstrelHt = DynamicCast<MinstrelHtWifiManager> (manager);
-          if (minstrelHt)
-            {
-              currentStream += minstrelHt->AssignStreams (currentStream);
-            }
+          currentStream += wifi->GetRemoteStationManager ()->AssignStreams (currentStream);
 
           //Handle any random numbers in the MAC objects.
           Ptr<WifiMac> mac = wifi->GetMac ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/wifi-helper.h ns-3.34/src/wifi/helper/wifi-helper.h
--- ns-3.33/src/wifi/helper/wifi-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/wifi-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -294,7 +294,7 @@
   virtual void EnablePcapInternal (std::string prefix,
                                    Ptr<NetDevice> nd,
                                    bool promiscuous,
-                                   bool explicitFilename);
+                                   bool explicitFilename) override;
 
   /**
    * \brief Enable ASCII trace output on the indicated net device.
@@ -310,7 +310,7 @@
   virtual void EnableAsciiInternal (Ptr<OutputStreamWrapper> stream,
                                     std::string prefix,
                                     Ptr<NetDevice> nd,
-                                    bool explicitFilename);
+                                    bool explicitFilename) override;
 
   PcapHelper::DataLinkType m_pcapDlt; ///< PCAP data link type
 };
@@ -402,39 +402,6 @@
                            std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
                            std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
 
-  /**
-   * \param ac the Access Category to attach the ack policy selector to.
-   * \param type the type of ns3::WifiAckPolicySelector to create.
-   * \param n0 the name of the attribute to set
-   * \param v0 the value of the attribute to set
-   * \param n1 the name of the attribute to set
-   * \param v1 the value of the attribute to set
-   * \param n2 the name of the attribute to set
-   * \param v2 the value of the attribute to set
-   * \param n3 the name of the attribute to set
-   * \param v3 the value of the attribute to set
-   * \param n4 the name of the attribute to set
-   * \param v4 the value of the attribute to set
-   * \param n5 the name of the attribute to set
-   * \param v5 the value of the attribute to set
-   * \param n6 the name of the attribute to set
-   * \param v6 the value of the attribute to set
-   * \param n7 the name of the attribute to set
-   * \param v7 the value of the attribute to set
-   *
-   * All the attributes specified in this method should exist
-   * in the requested ack policy selector.
-   */
-  void SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                  std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
-                                  std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
-                                  std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
-                                  std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
-                                  std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
-                                  std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
-                                  std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
-                                  std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
-
   /// Callback invoked to determine the MAC queue selected for a given packet
   typedef std::function<std::size_t (Ptr<QueueItem>)> SelectQueueCallback;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/wifi-mac-helper.cc ns-3.34/src/wifi/helper/wifi-mac-helper.cc
--- ns-3.33/src/wifi/helper/wifi-mac-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/wifi-mac-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -20,7 +20,10 @@
 
 #include "ns3/net-device.h"
 #include "wifi-mac-helper.h"
-#include "ns3/wifi-mac.h"
+#include "ns3/frame-exchange-manager.h"
+#include "ns3/wifi-protection-manager.h"
+#include "ns3/wifi-ack-manager.h"
+#include "ns3/multi-user-scheduler.h"
 #include "ns3/boolean.h"
 
 namespace ns3 {
@@ -30,45 +33,48 @@
   //By default, we create an AdHoc MAC layer without QoS.
   SetType ("ns3::AdhocWifiMac",
            "QosSupported", BooleanValue (false));
-}
 
-WifiMacHelper::~WifiMacHelper ()
-{
+  m_protectionManager.SetTypeId ("ns3::WifiDefaultProtectionManager");
+  m_ackManager.SetTypeId ("ns3::WifiDefaultAckManager");
 }
 
-void
-WifiMacHelper::SetType (std::string type,
-                        std::string n0, const AttributeValue &v0,
-                        std::string n1, const AttributeValue &v1,
-                        std::string n2, const AttributeValue &v2,
-                        std::string n3, const AttributeValue &v3,
-                        std::string n4, const AttributeValue &v4,
-                        std::string n5, const AttributeValue &v5,
-                        std::string n6, const AttributeValue &v6,
-                        std::string n7, const AttributeValue &v7,
-                        std::string n8, const AttributeValue &v8,
-                        std::string n9, const AttributeValue &v9,
-                        std::string n10, const AttributeValue &v10)
+WifiMacHelper::~WifiMacHelper ()
 {
-  m_mac.SetTypeId (type);
-  m_mac.Set (n0, v0);
-  m_mac.Set (n1, v1);
-  m_mac.Set (n2, v2);
-  m_mac.Set (n3, v3);
-  m_mac.Set (n4, v4);
-  m_mac.Set (n5, v5);
-  m_mac.Set (n6, v6);
-  m_mac.Set (n7, v7);
-  m_mac.Set (n8, v8);
-  m_mac.Set (n9, v9);
-  m_mac.Set (n10, v10);
 }
 
 Ptr<WifiMac>
-WifiMacHelper::Create (Ptr<NetDevice> device) const
+WifiMacHelper::Create (Ptr<NetDevice> device, WifiStandard standard) const
 {
+  auto standardIt = wifiStandards.find (standard);
+  NS_ABORT_MSG_IF (standardIt == wifiStandards.end (), "Selected standard is not defined!");
+
   Ptr<WifiMac> mac = m_mac.Create<WifiMac> ();
   mac->SetDevice (device);
+  mac->SetAddress (Mac48Address::Allocate ());
+  mac->ConfigureStandard (standard);
+
+  Ptr<RegularWifiMac> wifiMac = DynamicCast<RegularWifiMac> (mac);
+  Ptr<FrameExchangeManager> fem;
+
+  if (wifiMac != 0 && (fem = wifiMac->GetFrameExchangeManager ()) != 0)
+    {
+      Ptr<WifiProtectionManager> protectionManager = m_protectionManager.Create<WifiProtectionManager> ();
+      protectionManager->SetWifiMac (wifiMac);
+      fem->SetProtectionManager (protectionManager);
+
+      Ptr<WifiAckManager> ackManager = m_ackManager.Create<WifiAckManager> ();
+      ackManager->SetWifiMac (wifiMac);
+      fem->SetAckManager (ackManager);
+
+      // create and install the Multi User Scheduler if this is an HE AP
+      Ptr<ApWifiMac> apMac = DynamicCast<ApWifiMac> (mac);
+      if (apMac != nullptr && standardIt->second.macStandard >= WIFI_MAC_STANDARD_80211ax
+          && m_muScheduler.IsTypeIdSet ())
+        {
+          Ptr<MultiUserScheduler> muScheduler = m_muScheduler.Create<MultiUserScheduler> ();
+          apMac->AggregateObject (muScheduler);
+        }
+    }
   return mac;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/wifi-mac-helper.h ns-3.34/src/wifi/helper/wifi-mac-helper.h
--- ns-3.33/src/wifi/helper/wifi-mac-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/wifi-mac-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,6 +22,7 @@
 #define WIFI_MAC_HELPER_H
 
 #include "ns3/object-factory.h"
+#include "ns3/wifi-standards.h"
 
 namespace ns3 {
 
@@ -57,61 +58,105 @@
   virtual ~WifiMacHelper ();
 
   /**
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
    * \param type the type of ns3::WifiMac to create.
-   * Valid values of the type field must be a type subclassed from WifiMac.
-   *
-   * \param n0 the name of the attribute to set
-   * \param v0 the value of the attribute to set
-   * \param n1 the name of the attribute to set
-   * \param v1 the value of the attribute to set
-   * \param n2 the name of the attribute to set
-   * \param v2 the value of the attribute to set
-   * \param n3 the name of the attribute to set
-   * \param v3 the value of the attribute to set
-   * \param n4 the name of the attribute to set
-   * \param v4 the value of the attribute to set
-   * \param n5 the name of the attribute to set
-   * \param v5 the value of the attribute to set
-   * \param n6 the name of the attribute to set
-   * \param v6 the value of the attribute to set
-   * \param n7 the name of the attribute to set
-   * \param v7 the value of the attribute to set
-   * \param n8 the name of the attribute to set
-   * \param v8 the value of the attribute to set
-   * \param n9 the name of the attribute to set
-   * \param v9 the value of the attribute to set
-   * \param n10 the name of the attribute to set
-   * \param v10 the value of the attribute to set
+   * \param args A sequence of name-value pairs of the attributes to set.
    *
    * All the attributes specified in this method should exist
    * in the requested MAC.
    */
-  virtual void SetType (std::string type,
-                        std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
-                        std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
-                        std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
-                        std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
-                        std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
-                        std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
-                        std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
-                        std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue (),
-                        std::string n8 = "", const AttributeValue &v8 = EmptyAttributeValue (),
-                        std::string n9 = "", const AttributeValue &v9 = EmptyAttributeValue (),
-                        std::string n10 = "", const AttributeValue &v10 = EmptyAttributeValue ());
+  template <typename... Args>
+  void SetType (std::string type, Args&&... args);
+
+  /**
+   * Helper function used to set the Protection Manager.
+   *
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+   * \param type the type of Protection Manager
+   * \param args A sequence of name-value pairs of the attributes to set.
+   */
+  template <typename... Args>
+  void SetProtectionManager (std::string type, Args&&... args);
+
+  /**
+   * Helper function used to set the Acknowledgment Manager.
+   *
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+   * \param type the type of Acknowledgment Manager
+   * \param args A sequence of name-value pairs of the attributes to set.
+   */
+  template <typename... Args>
+  void SetAckManager (std::string type, Args&&... args);
+
+  /**
+   * Helper function used to set the Multi User Scheduler that can be aggregated
+   * to an HE AP's MAC.
+   *
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+   * \param type the type of Multi User Scheduler
+   * \param args A sequence of name-value pairs of the attributes to set.
+   */
+  template <typename... Args>
+  void SetMultiUserScheduler (std::string type, Args&&... args);
 
   /**
    * \param device the device within which the MAC object will reside
+   * \param standard the standard to configure during installation
    * \returns a new MAC object.
    *
    * This allows the ns3::WifiHelper class to create MAC objects from ns3::WifiHelper::Install.
    */
-  virtual Ptr<WifiMac> Create (Ptr<NetDevice> device) const;
+  virtual Ptr<WifiMac> Create (Ptr<NetDevice> device, WifiStandard standard) const;
 
 
 protected:
-  ObjectFactory m_mac; ///< MAC object factory
+  ObjectFactory m_mac;                ///< MAC object factory
+  ObjectFactory m_protectionManager;  ///< Factory to create a protection manager
+  ObjectFactory m_ackManager;         ///< Factory to create an acknowledgment manager
+  ObjectFactory m_muScheduler;        ///< Multi-user Scheduler object factory
 };
 
 } // namespace ns3
 
+
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3 {
+
+template <typename... Args>
+void
+WifiMacHelper::SetType (std::string type, Args&&... args)
+{
+  m_mac.SetTypeId (type);
+  m_mac.Set (args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetProtectionManager (std::string type, Args&&... args)
+{
+  m_protectionManager.SetTypeId (type);
+  m_protectionManager.Set (args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetAckManager (std::string type, Args&&... args)
+{
+  m_ackManager.SetTypeId (type);
+  m_ackManager.Set (args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetMultiUserScheduler (std::string type, Args&&... args)
+{
+  m_muScheduler.SetTypeId (type);
+  m_muScheduler.Set (args...);
+}
+
+} // namespace ns3
+
 #endif /* WIFI_MAC_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/wifi-radio-energy-model-helper.h ns-3.34/src/wifi/helper/wifi-radio-energy-model-helper.h
--- ns-3.33/src/wifi/helper/wifi-radio-energy-model-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/wifi-radio-energy-model-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -52,7 +52,7 @@
    *
    * Sets an attribute of the underlying PHY object.
    */
-  void Set (std::string name, const AttributeValue &v);
+  void Set (std::string name, const AttributeValue &v) override;
 
   /**
    * \param callback Callback function for energy depletion handling.
@@ -108,7 +108,7 @@
    * Implements DeviceEnergyModel::Install.
    */
   virtual Ptr<DeviceEnergyModel> DoInstall (Ptr<NetDevice> device,
-                                            Ptr<EnergySource> source) const;
+                                            Ptr<EnergySource> source) const override;
 
 private:
   ObjectFactory m_radioEnergy; ///< radio energy
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/helper/yans-wifi-helper.h ns-3.34/src/wifi/helper/yans-wifi-helper.h
--- ns-3.33/src/wifi/helper/yans-wifi-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/helper/yans-wifi-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -186,7 +186,7 @@
    *
    * This method implements the pure virtual method defined in \ref ns3::WifiPhyHelper.
    */
-  virtual Ptr<WifiPhy> Create (Ptr<Node> node, Ptr<NetDevice> device) const;
+  Ptr<WifiPhy> Create (Ptr<Node> node, Ptr<NetDevice> device) const override;
 
   Ptr<YansWifiChannel> m_channel; ///< YANS wifi channel
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/adhoc-wifi-mac.cc ns-3.34/src/wifi/model/adhoc-wifi-mac.cc
--- ns-3.33/src/wifi/model/adhoc-wifi-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/adhoc-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -23,10 +23,9 @@
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "adhoc-wifi-mac.h"
-#include "ht-capabilities.h"
-#include "vht-capabilities.h"
-#include "he-capabilities.h"
-#include "mac-low.h"
+#include "ns3/ht-capabilities.h"
+#include "ns3/vht-capabilities.h"
+#include "ns3/he-capabilities.h"
 
 namespace ns3 {
 
@@ -138,7 +137,7 @@
       hdr.SetNoOrder (); // explicitly set to 0 for the time being since HT control field is not yet implemented (set it to 1 when implemented)
     }
   hdr.SetAddr1 (to);
-  hdr.SetAddr2 (m_low->GetAddress ());
+  hdr.SetAddr2 (GetAddress ());
   hdr.SetAddr3 (GetBssid ());
   hdr.SetDsNotFrom ();
   hdr.SetDsNotTo ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/adhoc-wifi-mac.h ns-3.34/src/wifi/model/adhoc-wifi-mac.h
--- ns-3.33/src/wifi/model/adhoc-wifi-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/adhoc-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -44,13 +44,12 @@
   AdhocWifiMac ();
   virtual ~AdhocWifiMac ();
 
-  // Implementations of pure virtual methods, or overridden from base class.
-  void SetAddress (Mac48Address address);
-  void SetLinkUpCallback (Callback<void> linkUp);
-  void Enqueue (Ptr<Packet> packet, Mac48Address to);
+  void SetAddress (Mac48Address address) override;
+  void SetLinkUpCallback (Callback<void> linkUp) override;
+  void Enqueue (Ptr<Packet> packet, Mac48Address to) override;
 
 private:
-  void Receive (Ptr<WifiMacQueueItem> mpdu);
+  void Receive (Ptr<WifiMacQueueItem> mpdu) override;
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ampdu-subframe-header.h ns-3.34/src/wifi/model/ampdu-subframe-header.h
--- ns-3.33/src/wifi/model/ampdu-subframe-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ampdu-subframe-header.h	2021-07-14 10:31:07.000000000 -0700
@@ -41,11 +41,11 @@
    */
   static TypeId GetTypeId (void);
 
-  TypeId GetInstanceTypeId (void) const;
-  void Print (std::ostream &os) const;
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (Buffer::Iterator start) const;
-  uint32_t Deserialize (Buffer::Iterator start);
+  TypeId GetInstanceTypeId (void) const override;
+  void Print (std::ostream &os) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (Buffer::Iterator start) const override;
+  uint32_t Deserialize (Buffer::Iterator start) override;
 
   /**
    * Set the length field.
